#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Fri Mar 18 19:58:30 2022

@author: marina
"""
import numpy as np
import os
import cv2 as cv
import subprocess
from pathlib import Path
import sys
from skimage import io


import src.chen.Filter as Ft


def execute_bm3d(input_filename, output_filename):
    '''
    Eexecute bm3d
    '''
    line_exec = (f'./bm3d/BM3Ddenoising {input_filename} 5 0 0 0 {output_filename} 0 0 0 0 bior 0 dct 0 opp')
    subprocess.run(line_exec, shell=True)
    
def WaveletDenoising(file):
    Im = io.imread(file)
    Im = Im[:,:,1]
    ImNoise = Ft.NoiseExtractFromImage(Im, sigma=5., color=False, noZM=True)
    return ImNoise

def bm3dDenoising(file):
    Im = io.imread(file)
    image_name = Path(file).stem
    
    Im = Im[:,:,1]
    
    green_path = Path('../aux/green-channel/bm3d')
    green_path.mkdir(parents=True, exist_ok=True) 
    io.imsave(f'{green_path}/{image_name}.png', Im)
    
    denoised_path = Path('../aux/denoised/bm3d')
    denoised_path.mkdir(parents=True, exist_ok=True)   
    
    execute_bm3d(f'{green_path}/{image_name}.png', f'{denoised_path}/{image_name}.png')
    ImDenoised =  io.imread(f'{denoised_path}/{image_name}.png')
    ImNoise = Im - ImDenoised
    
    #if np.ndim(ImNoise)==3: ImNoise = ImNoise[:,:,::-1] # BGR2RGB
    #os.remove(f'{denoised_path}/{image_name}.png')
    #os.remove(f'{green_path}/{image_name}.png')
    os.remove('measures.txt')
    return ImNoise

def execute_dct_denoising(input_filename, output_filename):
    line_exec = (f'./DCTdenoising/demo_DCTdenoising {input_filename} 5 0 ImNoisy.png {output_filename}')
    subprocess.run(line_exec, shell=True)
    #os.remove('ImNoisy.png')
    
def DCTDenoising(file):
    Im = io.imread(file)
    image_name = Path(file).stem

    
    Im = Im[:,:,1]
    green_path = Path('../aux/green-channel/dct')
    green_path.mkdir(parents=True, exist_ok=True) 
    io.imsave(f'{green_path}/{image_name}.png', Im)
    
    denoised_path = Path('../aux/denoised/dct')
    denoised_path.mkdir(parents=True, exist_ok=True)  
    
    execute_dct_denoising(f'{green_path}/{image_name}.png', f'{denoised_path}/{image_name}.png')
    ImDenoised =  io.imread(f'{denoised_path}/{image_name}.png')
    ImNoise = Im - ImDenoised
    #if np.ndim(ImNoise)==3: ImNoise = ImNoise[:,:,::-1] # BGR2RGB
    #os.remove(f'{denoised_path}/{image_name}.png')
    #os.remove(f'{green_path}/{image_name}.png')
    return ImNoise   
