#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Fri Mar 18 20:19:40 2022

@author: marina
"""

import src.chen.Functions as Fu
import numpy as np
from numpy.fft import fft2, ifft2


def ZeroMean(RP):
    RP_ZM, _ = Fu.ZeroMean(RP, zType = 'col')
    RP_ZM,_ = Fu.ZeroMean(RP_ZM, zType = 'row')
    #LP = RP - RP_ZM
    return RP_ZM#, LP

def PeakDetection(R, w, t1, t2):
    
    x = int(R.shape[0]/16)
    y = int(R.shape[1]/16)
    R = R[0: x*16, 0:y*16]

    D = fft2(R[:,:])
    D = np.abs(D)
    P1 = np.zeros_like(D)
    P2 = np.zeros_like(D)
    M1 = np.zeros_like(D)
    M2 = np.zeros_like(D)
    count = 0
    while count <= 2:
        for u in range(D.shape[0]):
            for v in range(D.shape[1]):
                rad = int(w/2)
                D_aux = np.roll(D,[int(rad-u),int(rad-v)], axis=[0,1])
                
                NP1 = 1*np.logical_not(P1)
                NP1_aux = np.roll(NP1,[int(rad-u),int(rad-v)], axis=[0,1])
                DNP1 = np.sum(np.multiply(D_aux[0: w+1, 0: w+1], NP1_aux[0: w+1, 0: w+1]))
                SumNP1 = np.sum(NP1_aux[0: w+1, 0: w+1])
                M1[u,v] = DNP1/SumNP1

                NP2 = 1*np.logical_not(P2)
                NP2_aux = np.roll(NP2,[int(rad-u),int(rad-v)], axis=[0,1])
                DNP2 = np.sum(np.multiply(D_aux[0: w+1, 0: w+1], NP2_aux[0: w+1, 0: w+1]))
                SumNP2 = np.sum(NP2_aux[0: w+1, 0: w+1])
                M2[u,v] = DNP2/SumNP2
                
        P1 = 1*(np.divide(D, M1)>= t1)
        P2 = 1*(np.divide(D, M2)>= t2)
        count += 1
        
    ### HAY QUE TENER CUIDADO CUANDO EL TAMAÑO NO ES DIVISIBLE POR 16
    ### TAL VEZ LO MÁS FACIL ES TOMAR UNA IMAGEN CON PATRON PERIODICO DE PERIODO 16 Y HACERLE LA fft
    
    U = int(D.shape[0]/16)
    V = int(D.shape[1]/16)
    B = np.zeros_like(D)
    for u in range(16):
        for v in range(16):
            B[U*u, V*v] = 1
    P = np.logical_or(np.logical_and(P1,B), P2)
    return P#, B, np.logical_and(P1,B), P1, P2

def PeakSupression(R, P, w):
    D = fft2(R[:,:])
    Dmag = np.abs(D)
    L = np.zeros_like(Dmag)
    for u in range(Dmag.shape[0]):
        for v in range(Dmag.shape[1]):
            if P[u,v] == 1:
                rad = int(w/2)
                Dmag_aux = np.roll(Dmag,[int(rad-u),int(rad-v)], axis=[0,1])

                NP = 1*np.logical_not(P)
                NP_aux = np.roll(NP,[int(rad-u),int(rad-v)], axis=[0,1])
                DmagNP = np.sum(np.multiply(Dmag_aux[0: w+1, 0: w+1], NP_aux[0: w+1, 0: w+1]))
                SumNP = np.sum(NP_aux[0: w+1, 0: w+1])
                L[u,v] = DmagNP/SumNP
            else:
                L[u,v] = Dmag[u,v]
    return ifft2(np.divide(np.multiply(L, D), Dmag))

def Wiener(ImNoise):
    sigma = np.std(ImNoise)
    ImNoise =Fu.WienerInDFT(ImNoise, sigma)
    return ImNoise

def SEA(ImNoise):
    P = PeakDetection(ImNoise, 17, 3, 3.4)
    ImNoise = PeakSupression(ImNoise, P, 15)
    return ImNoise


    
